# React Scroll Jacker 
React Scroll Jacker is a ruthless component that takes no ransom for his hijacked components. Rather, he hijacks scrolls for sweet tears of UX designers and users. Your hijacked scroll will only return after a set amount of pixel has been scrolled.

Instead of using scroll to scroll the page like a sane person, this component lets you use scroll to transition between elements for a specified amount of pixels. Under the hood, it takes React Children and shows them one by one, depending on the scrolled distance.

[Demo](https://scroller-jacker-demo.herokuapp.com/)

## Installation

```
$ npm install --save react-scroll-jacker
```

## Usage

1. Add Elements to ```<ReactScrollJacker>```.
2. Set the height of ```<ReactScrollJacker>``` to the sum of all its children.
3. Enjoy.

```javascript
import React from "react";
import ReactScrollJacker from "react-scroll-jacker";

const ScrollerJackerTest = props => {
  return <ReactScrollJacker height={2400}>  {/* <-- this should be the sum of all children's height! */}
      <ReactElement color="red"> Help! </ReactElement> 
      <ReactElement color="blue"> Our scroll has been hijacked! </ReactElement> 
      <ReactElement color="purple"> Wont somebody please think of the UX ? </ReactElement>
      <ReactElement color="green"> UX?? Where we are going, we dont need UX. </ReactElement>
      
      {/* you can add any number of ReactElements in here !! */}
    </ReactScrollJacker>
};
```

## Props

#### height *(number: required )*
**Recommended to be the total sum of all _React.Children_'s height for a smooth scroll jacking experience.**
This sets the total amount of pixel that needs to be scrolled before the hijacker lets your precious scroll go. 

This is divided by the number of the React.Children elements and used to create boundaries between the elements. For example, let's say the height is 400 and there are 4 _React.Children_. From 0px to 99px, it will show the first child, 100px to 199px will show the second child and so on.

#### stickyOffset *(number: optional)*
this sets the offset of the stickied element from the top of the viewbox.

#### injectChildren *(optional)*
This will inject the _React.Children_ with a prop({ currentPage: number }).
```javascript
  <ReactScrollJacker injectChildren height={1000}>
    <ReactElementOne> Help! </ReactElementOne>  
    <ReactElementOne> I did not ask for this! </ReactElementOne>
  </ReactScrollJacker>

   // ReactElementOnes will have get a prop  _currentPage_. 
```

This component is a regular div. _style_ and _className_ props are exposed. Style it however you wish.

## Todo
- [ ] Add Tests.
- [x] Add Demo.
- [ ] Add an option to pass down inject and not hide the children automatically.
- [ ] apologise to the UX designers and users.



